import Taro from '@tarojs/taro';
import ttappid from '../../project.tt.json'
import wxappid from '../../project.config.json'
import kwaiappid from '../../project.kwai.json'
import {
  baseUrl
} from './config';


export default (options = {
  method: 'GET',
  data: {}
}) => {
  const request_data = {
    session_key: Taro.getStorageSync('session_key') || '',
    channel_name: Taro.getStorageSync('channel_name') || 'channel_name',
    source_name: Taro.getStorageSync('source_name') || 'source_name',
  };
  if (process.env.TARO_ENV === 'weapp') {
    request_data['appid'] = wxappid.appid
  } else if (process.env.TARO_ENV === 'tt') {
    request_data['appid'] = ttappid.appid
  }else if (process.env.TARO_ENV === 'kwai') {
    request_data['appid'] = kwaiappid.appid
  }
  return Taro.request({
    url: baseUrl + options.url,
    data: {
      ...request_data,
      ...options.data,
    },
    header: {
      'Content-Type': 'application/json',
      'accept': 'application/json'
    },
    method: options.method.toUpperCase(),
  }).then(res => {
    const {
      statusCode,
      data
    } = res;
    const _res = Taro.getStorageInfoSync()
    let notApiStr = '/api/get_app_config;/api/login;/api/report_login;/api/video/video_detail;/api/pay/get_my_wallet;/api/get_template_list'
    
    if (statusCode == 200) {
      return data;
    } else {
      Taro.showToast({
        title: `${res.msg}~`,
        icon: 'none',
        mask: true,
      });
    }
  });
};