import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import * as api from '../../service/index'
import tool from '../../common/tool'
import Taro, { } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  state = {
    list: [],
    page: 1,
    page_size: 20,
    total: false
  }

  componentWillMount () {
  }
  componentDidShow () {
    this.init()
  }
  init () {
    this.setState({
      list: [],
      page: 1,
      page_size: 20,
      total: false
    }, () => {

      this.aiInformationIndex()
    })
  }
  aiInformationIndex () {
    Taro.showLoading({
      title: '加载中...'
    })
    let params = {
      page: this.state.page,
      page_size: this.state.page_size
    }
    api.aiInformationIndex(params).then(res => {
      Taro.hideLoading();
      if (res.code == 200) {
        let total = true
        if (res.data.length < this.state.page_size) {
          total = false
        }
        let walletList = this.state.list.concat(res.data)
        this.setState({
          list: walletList,
          total: total,
        })
      }
    })
  }
  onShareAppMessage = (res) => {
    let path = `/pages/index/index?c=${Taro.getStorageSync('user_id')}&s=rightTap`
    if (process.env.TARO_ENV == 'tt') {
      path = `/pages/index/index?c=channel_name&s=douyinguazai`
    }
    let shareData = {
      title: tool.shareTitle,
      path: path,
      imageUrl: tool.shareImg
    }
    return shareData;
  }
  onReachBottom () {
    if (!this.state.total) return
    this.setState({
      page: this.state.page + 1
    }, () => {
      this.getUserShareCnt()
    })
  }
  toActInfo (item) {
    let url = `${item.jump_url}`
    Taro.navigateTo({
      url: url
    })
  }

  render () {
    return (
      <View className='mine'>
        {
          this.state.list.map((item, index) => (
            <View className='act-info' key={index} onClick={e => (this.toActInfo(item))}>
              <View className='info-content'>
                {
                  item.type == 1 &&
                  <View className='tips' style={`background-color: ${item.label_background};`}>
                    {item.label_text}
                  </View>
                }
                <View className='info-left'>
                  <View className='left-title'>{item.title}</View>
                  <View className='left-content'>{tool.ellipsis(item.sub_title, 35)}</View>
                </View>
                <Image className='info-right' src={item.img}></Image>
              </View>
            </View>
          ))
        }
      </View>
    )
  }
}
