import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import * as api from '../../service/index'
import tool from '../../common/tool'
import Taro, { } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  state = {
    tableIndex: 0,
    total: false,
    page: 1,
    page_size: 20,
    cardinalInfos: [],//基数
    evenInfos: [],//偶数
    type: 'hot',//hot:热门，time:最新
  }

  componentWillMount () {
    this.setInit(1, 'hot')
  }
  componentDidShow(){
    // this.setInit(1, 'hot')
  }
  setInit (page, type) {
    this.setState({
      total: false,//是否加载完
      page: 1,
      page_size: 20,
      cardinalInfos: [],//基数
      evenInfos: [],//偶数
    })
    this.getHubList(page, type)
  }
  onShareAppMessage = (res) => {
    let shareData = {
      title:tool.shareTitle,
      path: `/pages/index/index?c=${Taro.getStorageSync('user_id')}&s=rightTap`,
      imageUrl: tool.shareImg
    }
    return shareData;
  }

  getHubList (page, type) {
    let params = {
      page: page,
      page_size: this.state.page_size,
      otype: type
    }
    Taro.showLoading({
      title: '加载中',
    })
    api.getHubList(params).then(res => {
      if (res.code == 200) {
        Taro.hideLoading()
        let _evenInfos = res.data.filter((item, index) => {
          return index % 2 == 1
        })
        let _cardinalInfos = res.data.filter((item, index) => {
          return index % 2 == 0
        })
        console.log(_cardinalInfos, '_cardinalInfos');
        let cardinalInfos = this.state.cardinalInfos.concat(_cardinalInfos)
        let evenInfos = this.state.evenInfos.concat(_evenInfos)
        this.setState({
          cardinalInfos: cardinalInfos,//基数
          evenInfos: evenInfos,//偶数
          total: res.data.length < 20 ? true : false
        })
      }
    })
  }
  onReachBottom () {
    if (!this.state.total) {
      this.setState({
        page: this.state.page + 1
      })
      this.getHubList((this.state.page + 1), this.state.type)
    }
  }
  componentDidHide () { }
  changeTab (index) {
    let _type = index == 0 ? 'hot' : 'time'
    this.setState({
      tableIndex: index,
      type: _type
    })
    this.setInit(1, _type)
  }
  detail (item, index) {
    console.log(item, 'item');
    Taro.navigateTo({
      url: `/pages/communityDetail/index?task_id=${item.id}`
    })
  }

  render () {
    return (
      <View className='mine'>
        <View className='table'>
          <View className='table-info' onClick={e => (this.changeTab(0))} style={this.state.tableIndex == 0 ? 'font-size: 20px;color: #FFFFFF;border-bottom: 4px solid #0F84EC;' : ''}>热门</View>
          <View className='table-info' onClick={e => (this.changeTab(1))} style={this.state.tableIndex == 1 ? 'font-size: 20px;color: #FFFFFF;border-bottom: 4px solid #0F84EC;' : ''}>最新</View>
        </View>
        <View className='image-list'>
          <View className='list-left'>
            {
              this.state.cardinalInfos.map((item, index) => (
                <View className='image-info' key={index} onClick={e => (this.detail(item, index))}>
                  <View className='info-top'>
                    <Image className='info-img' lazyLoad mode='widthFix' src={item.img}></Image>
                  </View>
                  <View className='info-bottom'>
                    <View className='info-name'></View>
                    <View className='info-tips'>
                      <View className='info-tips-left'>
                        <Image className='info-head-img' src={item.user_info.head_img}></Image>
                        <View className='info-sampling'>{tool.ellipsis(item.user_info.user_name, 8)}</View>
                      </View>
                      <View className='info-tips-right'>
                        <Image className='info-like-img' src={item.has_like == 0 ? 'https://we-spa.oss-cn-shenzhen.aliyuncs.com/total_picture/1679296882735.png' : 'https://we-spa.oss-cn-shenzhen.aliyuncs.com/total_picture/1679296893058.png'}></Image>
                        <View className='like-num'>{item.like_cnt}</View>
                      </View>
                    </View>
                  </View>
                </View>
              ))
            }
          </View>
          <View className='list-right'>
            {
              this.state.evenInfos.map((item, index) => (
                <View className='image-info' key={index} onClick={e => (this.detail(item, index))}>
                  <View className='info-top'>
                    <Image className='info-img' lazyLoad mode='widthFix' src={item.img}></Image>
                  </View>
                  <View className='info-bottom'>
                    <View className='info-name'></View>
                    <View className='info-tips'>
                      <View className='info-tips-left'>
                        <Image className='info-head-img' src={item.user_info.head_img}></Image>
                        <View className='info-sampling'>{tool.ellipsis(item.user_info.user_name, 8)}</View>
                      </View>
                      <View className='info-tips-right'>
                        <Image className='info-like-img' src={item.has_like == 0 ? 'https://we-spa.oss-cn-shenzhen.aliyuncs.com/total_picture/1679296882735.png' : 'https://we-spa.oss-cn-shenzhen.aliyuncs.com/total_picture/1679296893058.png'}></Image>
                        <View className='like-num'>{item.like_cnt}</View>
                      </View>
                    </View>
                  </View>
                </View>
              ))
            }
          </View>

        </View>
      </View>
    )
  }
}
