import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import * as api from '../../service/index'
import tool from '../../common/tool'
import Taro, { } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  state = {
    consultImg: 'http://video-img.fyshark.com/1681721632520%E4%B8%8A.png',
    sizeIndex: 0,
    mass: 0,
    modelIndex: 0,
    isImage: false,
    creatInfo: {},
    isOpen: false,
    jumpurl: '',//广告id
    task_id: 0,//任务id
    repeat: 0,//广告次数
    drawTaskId:0,//任务id
  }

  componentWillMount () {
    this.getDrawGcImgIndex()
    this.getCoinTaskAd()
  }
  componentDidShow () {
    //接收裁剪图片
    let pages = Taro.getCurrentPages();
    let currentPage = pages[pages.length - 1]; // 获取当前页面
    console.log(currentPage, 'currentPage');
    if (process.env.TARO_ENV == 'weapp') {
      if (currentPage.__data__.consultImg) { // 获取值
        this.setState({
          consultImg: currentPage.__data__.consultImg,
          sizeIndex: currentPage.__data__.sizeIndex,
          isImage: true
        })
        currentPage.__data__.consultImg = ''
      }
    } else if (process.env.TARO_ENV == 'tt') {
      if (currentPage.data.consultImg) { // 获取值
        this.setState({
          consultImg: currentPage.data.consultImg,
          sizeIndex: currentPage.data.sizeIndex,
          isImage: true
        })
        currentPage.data.consultImg = ''
      }
    }
  }
  getCoinTaskAd () {
    api.getCoinTaskAd().then(res => {
      if (res.code == 200) {
        this.setState({
          jumpurl: res.data[0].jumpurl,//广告id
          task_id: res.data[0].id,//任务id
          repeat: res.data[0].repeat
        })
      }
    })
  }
  getDrawGcImgIndex () {
    api.getDrawGcImgIndex().then(res => {
      if (res.code == 200) {
        this.setState({
          creatInfo: res.data
        })
      }
    })
  }
  changeOpen () {
    this.setState({
      isOpen: !this.state.isOpen
    })
  }
  updateButton () {
    if (!this.state.isImage) {
      this.upLode()
    } else if (this.state.creatInfo.wallet_status == 0) {
      this.playVideoGeneratePictures()
    } else {
      this.generatePictures()
    }
  }
  //上传图片
  upLode () {
    let that = this
    ks.chooseImage({
      count: 1, // 默认
      sizeType: ['compressed'], // 可以指定是原图还是压缩图，默认二者都有
      mediaType:['image'],
      sourceType: ['album', 'camera'],
      success: function (res) {
        console.log(res, 'res');
        const file = res.tempFiles[0].tempFilePath
        if (res.tempFiles[0].size > 2000000) {
          Taro.showToast({ title: '图片大小不能超过2M', icon: 'none' })
          return
        }
        Taro.showLoading({
          title: '图片上传中',
        })
        Taro.hideLoading()
        Taro.navigateTo({
          url: `/pages/upload/index?image=${file}`
        })
      }
    })
  }
  //画图
  generatePictures () {
    if (!this.state.isImage) {
      Taro.showToast({ title: '请先上传图片', icon: 'none' })
      return
    }
    api.drawGcImg({ img_url: this.state.consultImg, style_id: this.state.creatInfo.models[this.state.modelIndex].id }).then(res => {
      if (res.code == 200) {
        Taro.navigateTo({
          url: `/pages/comicDetail/index?task_id=${res.data.task_id}`
        })
      } else {
        Taro.hideLoading()
        Taro.showToast({ icon: 'none', title: res.msg })
      }
    })
  }
  //看广告画图
  playVideoGeneratePictures () {
    if (!this.state.isImage) {
      Taro.showToast({ title: '请先上传图片', icon: 'none' })
      return
    }
    api.drawGcImg({ img_url: this.state.consultImg, style_id: this.state.creatInfo.models[this.state.modelIndex].id }).then(res => {
      if (res.code == 200) {
        this.setState({
          drawTaskId:res.data.task_id
        },()=>{
          console.log(res.data.task_id,'res.data.task_id');
          this.playVideo()
        })
       
      } else {
        Taro.hideLoading()
        Taro.showToast({ icon: 'none', title: res.msg })
      }
    })
  }

  //观看广告
  playVideo () {
    if (process.env.TARO_ENV == 'tt') {
      this.playVideoTT()
    } else {
      this.playVideoWeapp()
    }
  }
  //抖音激励广告
  playVideoTT () {
    let that = this
    Taro.showLoading({
      title: '加载中...',
    })
    const videoAd = tt.createRewardedVideoAd({ adUnitId: this.state.jumpurl });
    videoAd.show()
    videoAd.onError((err) => {
      Taro.hideLoading()
      switch (err.errCode) {
        case 1004:
          // 无合适的广告
          break;
        default:
        // 更多请参考错误码文档
      }
    });
    try {
      if (videoAd.closeHandler) {
        videoAd.offClose(videoAd.closeHandler);
        console.log("videoAd.offClose卸载成功");
      }
    } catch (e) {
      console.log("videoAd.offClose 卸载失败");
      console.error(e);
    }
    videoAd.closeHandler = function (data) {
      Taro.hideLoading()
      if (data.isEnded) {
        Taro.navigateTo({
          url: `/pages/comicDetail/index?task_id=${that.state.drawTaskId}`
        })
      } else {
       
      }
    }
    // 监听视频播放完成
    videoAd.onClose(videoAd.closeHandler);
  }
  //激励广告
  playVideoWeapp () {
    // 在页面中定义激励视频广告
    let adUnitId = this.state.jumpurl
    // 在页面中定义激励视频广告
    let videoAd = null
    let that = this
    console.log(videoAd, 'videoAd');
    // 在页面onLoad回调事件中创建激励视频广告实例
    if (wx.createRewardedVideoAd) {
      videoAd = wx.createRewardedVideoAd({
        adUnitId: adUnitId
      })
      videoAd.onLoad(() => { })
      videoAd.onError((err) => { })
      try {
        if (videoAd.closeHandler) {
          videoAd.offClose(videoAd.closeHandler);
          console.log("videoAd.offClose卸载成功");
        }
      } catch (e) {
        console.log("videoAd.offClose 卸载失败");
        console.error(e);
      }
      videoAd.closeHandler = function (res) {
        // 用户点击了【关闭广告】按钮
        if (res && res.isEnded || res === undefined) {
          // 正常播放结束，可以下发游戏奖励
          Taro.navigateTo({
            url: `/pages/comicDetail/index?task_id=${that.state.drawTaskId}`
          })
        } else {
          //提前关闭小程序
        }
      };
      videoAd.onClose(videoAd.closeHandler);
    }

    // 用户触发广告后，显示激励视频广告
    if (videoAd) {
      videoAd.show().catch(() => {
        // 失败重试
        videoAd.load()
          .then(() => videoAd.show())
          .catch(err => {
            Taro.showToast({
              title: '暂无广告',
              icon: 'none',
              duration: 2000
            })
            console.log('激励视频 广告显示失败')
          })
      })
    }

  }
  deleteImg () {
    this.setState({
      consultImg: 'http://video-img.fyshark.com/1681721632520%E4%B8%8A.png',
      isImage: false,
    })
  }
  onShareAppMessage = (res) => {
    let path = `/pages/index/index?c=${Taro.getStorageSync('user_id')}&s=rightTap`
    if (process.env.TARO_ENV == 'tt') {
      path = `/pages/index/index?c=channel_name&s=douyinguazai`
    }
    let shareData = {
      title: tool.shareTitle,
      path: path,
      imageUrl: tool.shareImg
    }
    return shareData;
  }
  changeMass (e) {
    this.setState({
      mass: e
    })
  }
  selectModel (item, index) {
    this.setState({
      modelIndex: index,
    })
  }

  render () {
    return (
      <View className='mine'>
        <View className='banner'>
          <View className='banner-content'>

            <Image className='content-img'
              mode='aspectFit'
              src={this.state.consultImg}
            ></Image>
            {
              this.state.isImage &&
              <Image className='delete' src='http://video-img.fyshark.com/1680147210173guanbi.png' onClick={e => (this.deleteImg())}></Image>
            }
          </View>
          <View className='banner-tips'>绝美的动漫头像，上传图片一键生成</View>

        </View>
        {
          this.state.creatInfo.models &&
          <View className='model-list'>
            {

              !this.state.isOpen ?
                this.state.creatInfo.models.slice(0, 6).map((item, index) => (
                  <View className='model-info'
                    style={`background:url(${item.img});background-size: 100% 100%;`}
                    key={index}
                    onClick={e => (this.selectModel(item, index))}>
                    <View className='model-info-bottom'>
                      {item.name}
                    </View>
                    {
                      this.state.modelIndex == index &&
                      <View className='moonlight'>
                        {item.name}
                      </View>
                    }
                  </View>
                )) :
                this.state.creatInfo.models.map((item, index) => (
                  <View className='model-info'
                    style={`background:url(${item.img});background-size: 100% 100%;`}
                    key={index}
                    onClick={e => (this.selectModel(item, index))}>
                    <View className='model-info-bottom'>
                      {item.name}
                    </View>
                    {
                      this.state.modelIndex == index &&
                      <View className='moonlight'>
                        {item.name}
                      </View>
                    }
                  </View>
                ))
            }
          </View>
        }
        {
          this.state.creatInfo.models && this.state.creatInfo.models.length > 6 &&
          <View className='isOpen'>
            <View className='open-content' onClick={e => (this.changeOpen())}>
              <View className='open-title'>{!this.state.isOpen ? '展开' : '收起'}</View>
              <Image className='open-img' src={!this.state.isOpen ? 'https://we-spa.oss-cn-shenzhen.aliyuncs.com/total_picture/1678935050487.png' : 'https://we-spa.oss-cn-shenzhen.aliyuncs.com/total_picture/1678935114571.png'}></Image>
            </View>
          </View>
        }
        <View className='update' onClick={e => (tool.throttle(this.updateButton()), 2000)}>
          <View className='update-button'>
            <Image className='update-img' src={!this.state.isImage ? 'http://video-img.fyshark.com/1681719589061%E7%BB%98%E7%94%BB%402x.png' : 'http://video-img.fyshark.com/1681719637510%E5%9B%BE%E7%89%87%402x.png'}></Image>
            {!this.state.isImage ? '上传图片' : this.state.creatInfo.wallet_status == 0 ? '点击看广告绘制图片' : '点击绘制 (当前点券充足，前往绘制吧）'}
          </View>
        </View>
        <View className='tip-img'>
          <Image className='ps-image' src='http://video-img.fyshark.com/1681720619915%E4%B8%8B%E5%9B%BE.png'></Image>
        </View>

      </View>
    )
  }
}
