import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import * as api from '../../service/index'
import tool from '../../common/tool'
import Taro, { getCurrentInstance } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  $instance = getCurrentInstance()
  state = {
    consultImg: 'https://video-h5.fyshark.com/1680752646217.png',
    consultImgOther: 'https://video-h5.fyshark.com/1680778269657.png',
    resultImage: '',
    mass: 0,
    isModelImage: false,
    isUserImage: false,
    isRsoutImage: false,
    isChangeButton: false,
    type: ''
  }

  componentWillMount () {
    let routers = this.$instance.router.params
    console.log(routers, 'routers');
    if (routers.img) {
      this.setState({
        consultImg: routers.img,
        isModelImage: true,
      })
    }

  }
  componentDidShow () {
    this.getImage()
  }
  onShareAppMessage = (res) => {
    let path = `/pages/index/index?c=${Taro.getStorageSync('user_id')}&s=rightTap`
    if (process.env.TARO_ENV == 'tt') {
      path = `/pages/index/index?c=channel_name&s=douyinguazai`
    }
    let shareData = {
      title: tool.shareTitle,
      path: path,
      imageUrl: tool.shareImg
    }
    return shareData;
  }
  getImage () {
    //接收裁剪图片
    let pages = Taro.getCurrentPages();
    let currentPage = pages[pages.length - 1]; // 获取当前页面
    console.log(currentPage, 'currentPage');
    if (process.env.TARO_ENV == 'weapp') {
      if (currentPage.__data__.consultImg) { // 获取值
        if (this.state.type == 'demol') {
          this.setState({
            consultImg: currentPage.__data__.consultImg,
            isModelImage: true
          }, () => {
            currentPage.__data__.consultImg = ''
          })
        } else {
          this.setState({
            consultImgOther: currentPage.__data__.consultImg,
            isUserImage: true
          }, () => {
            currentPage.__data__.consultImg = ''
          })
        }

      }
    } else if (process.env.TARO_ENV == 'tt') {
      if (currentPage.data.consultImg) { // 获取值
        if (this.state.type == 'demol') {
          this.setState({
            consultImg: currentPage.data.consultImg,
            isModelImage: true
          }, () => {
            currentPage.data.consultImg = ''
          })
        } else {
          this.setState({
            consultImgOther: currentPage.data.consultImg,
            isUserImage: true
          }, () => {
            currentPage.data.consultImg = ''
          })
        }
      }
    }
  }
  upLode (type) {
    let that = this
    this.setState({
      type: type
    })
    if (type == 'demol') {
      this.setState({
        isRsoutImage: false,
        isChangeButton: false
      })
    }
    ks.chooseImage({
      count: 1, // 默认
      sizeType: ['compressed'], // 可以指定是原图还是压缩图，默认二者都有
      mediaType:['image'],
      sourceType: ['album', 'camera'],
      success: function (res) {
        console.log(res, 'res');
        const file = res.tempFiles[0].tempFilePath
        if (res.tempFiles[0].size > 2000000) {
          Taro.showToast({ title: '图片大小不能超过2M', icon: 'none' })
          return
        }
        Taro.showLoading({
          title: '图片上传中',
        })
        Taro.hideLoading()
        Taro.navigateTo({
          url: `/pages/upload/index?image=${file}`
        })
      }
    })
  }
  generatePictures () {
    if (!this.state.isModelImage) {
      Taro.showToast({ title: '请先上传模板图', icon: 'none' })
      return
    }
    if (this.state.isRsoutImage) {
      Taro.showToast({ title: '请重新上传模板图', icon: 'none' })
      return
    }
    if (!this.state.isUserImage) {
      Taro.showToast({ title: '请先上传人脸图', icon: 'none' })
      return
    }
    Taro.showLoading({
      title: '加载中...',
    })
    let params = {
      image_template: this.state.consultImg,
      image_target: this.state.consultImgOther,
    }
    api.aiFaceMege(params).then(res => {
      if (res.code == 200) {
        Taro.hideLoading()
        console.log(`data:image/png;base64,${res.data.imgdata}`, '1111');
        this.setState({
          resultImage: `data:image/png;base64,${res.data.imgdata}`,
          isRsoutImage: true,
          isChangeButton: true
        })
      } else {
        Taro.hideLoading()
        if (res.code == 4001) {
          Taro.showModal({
            title: '您的余额不足',
            content: '是否前往获取点券？',
            success: function (res) {
              if (res.confirm) {
                Taro.navigateTo({
                  url: `/pages/earnPoints/index`
                })
              } else if (res.cancel) {
                console.log('用户点击取消')
              }
            }
          })
        } else {
          Taro.showToast({ icon: 'none', title: res.msg })
        }
      }
    })
  }
  previewImage () {
    Taro.previewImage({
      current: this.state.isRsoutImage ? this.state.resultImage : this.state.consultImg, // 当前显示图片的http链接  
      urls: [`${this.state.isRsoutImage ? this.state.resultImage : this.state.consultImg}`] // 需要预览的图片http链接列表  
    })
  }
  previewUserImage () {
    Taro.previewImage({
      current: this.state.consultImgOther, // 当前显示图片的http链接  
      urls: [`${this.state.consultImgOther}`] // 需要预览的图片http链接列表  
    })
  }
  changeMass (e) {
    this.setState({
      mass: e
    })
  }
  onTouchStart () {
    this.setState({
      isRsoutImage: false
    })
  }
  onTouchEnd () {
    this.setState({
      isRsoutImage: true
    })
  }

  render () {
    return (
      <View className='mine'>
        <View className='demo'>
          <Image className='demo-img' mode='aspectFit' onClick={e => (this.previewImage())} src={this.state.isRsoutImage ? this.state.resultImage : this.state.consultImg}></Image>
          <View className='update' onClick={e => (this.upLode('demol'))}>
            <Image className='updata-img' src='http://video-img.fyshark.com/1680849432427%E4%B8%8A%E4%BC%A0%E5%9B%BE%E7%89%87.png'></Image>
            {
              !this.state.isModelImage &&
              <View className='from'></View>
            }
            <View className='updata-title'>上传模板图</View>
          </View>
          {
            this.state.isChangeButton &&
            <View className='changeImg'
              onTouchStart={e => (this.onTouchStart())}
              onTouchEnd={e => (this.onTouchEnd())}>
              <Image className='change-img' src='http://video-img.fyshark.com/1680851265492%E5%88%87%E6%8D%A2%20(1).png'></Image>
            </View>
          }
        </View>
        <View className='demo'>
          <Image className='demo-img' mode='aspectFit' onClick={e => (this.previewUserImage())} src={this.state.consultImgOther}></Image>
          <View className='update' onClick={e => (this.upLode('user'))}>
            <Image className='updata-img' src='http://video-img.fyshark.com/1680849432427%E4%B8%8A%E4%BC%A0%E5%9B%BE%E7%89%87.png'></Image>
            {
              !this.state.isUserImage &&
              <View className='from'></View>
            }
            <View className='updata-title'>上传人脸图</View>
          </View>
        </View>
        <View className='tips'>
          <View>注意：</View>
          <View>1、图片生成成功后会保存在自己到作品，可前往作品下载。</View>
          <View>2、人脸图尽量不要有遮挡物，比如眼镜、手部遮挡等。</View>
        </View>
        <View className='generate-pictures' onClick={e => (this.generatePictures(e))} >
          生成图片（消耗{4}点券）
        </View>
      </View>
    )
  }
}
