import { Component } from 'react'
import { View, RichText } from '@tarojs/components'
import Taro, { getCurrentInstance, CanvasContext } from '@tarojs/taro'
import tool from '../../common/tool'
import * as api from '../../service/index'
import './index.less'

export default class Task extends Component {
  $instance = getCurrentInstance()
  state = {
    info: {}
  }

  componentDidShow () {
    this.getInformationDetails()
  }
  getInformationDetails () {
    let routers = this.$instance.router.params
    let params = {
      detail_id: routers.task_id
    }
    api.getInformationDetails(params).then(res => {
      if (res.code == 200) {
        this.setState({
          info: res.data
        })
      }
    })
  }

  onShareAppMessage = (res) => {
    let path = `/pages/index/index?c=${Taro.getStorageSync('user_id')}&s=rightTap`
    if (process.env.TARO_ENV == 'tt') {
      path = `/pages/index/index?c=channel_name&s=douyinguazai`
    }
    let shareData = {
      title: tool.shareTitle,
      path: path,
      imageUrl: tool.shareImg
    }
    return shareData;
  }

  render () {
    return (
      <View className='mine'>
        <RichText className='member-title' nodes={this.state.info.content}></RichText>
      </View>
    )
  }
}
