import React, { Component } from 'react'
import { View, Text, Button, Image, ScrollView, Input } from '@tarojs/components'
import Taro, { getCurrentInstance } from '@tarojs/taro'
import TaroCropper from 'taro-cropper';
import tool from '../../common/tool'
import * as api from '../../service/index'

import './index.less'

export default class Mine extends Component {
  $instance = getCurrentInstance()
  inputRef = React.createRef();
  state = {
    src: '',
    cutImagePath: '',
    cropperWidth: 500,
    cropperHeight: 500,
    imgSize: [],
    sizeIndex: 0
  }

  componentDidShow () {
    let routers = this.$instance.router.params
    this.setState({
      src: routers.image
    })
    console.log(routers, 'routers');
    this.getDrawIndex()
  }
  getDrawIndex () {
    api.getDrawIndex().then(res => {
      if (res.code == 200) {
        this.setState({
          imgSize: res.data.img_size,
        }, () => {
          let routers = this.$instance.router.params
          console.log(routers, 'rou');
          if (routers.task_id) {
            Taro.showLoading({
              title: '加载中',
            })
            this.getDrawTaskStatus()
          }
        })
      }
    })
  }
  changeMeasurement (item, index) {
    let cropperHeight = 500
    console.log(item);
    let sizeList = item.name.split(":")
    cropperHeight = 500 * sizeList[1] / sizeList[0]
    console.log(cropperHeight, 'cropperHeight');
    this.setState({
      sizeIndex: index,
      cropperHeight: cropperHeight
    })
  }
  onShareAppMessage = (res) => {
    let path = `/pages/index/index?c=${Taro.getStorageSync('user_id')}&s=rightTap`
    if (process.env.TARO_ENV == 'tt') {
      path = `/pages/index/index?c=channel_name&s=douyinguazai`
    }
    let shareData = {
      title: tool.shareTitle,
      path: path,
      imageUrl: tool.shareImg
    }
    return shareData;
  }
  onCut(e){
    Taro.showLoading({
      title: '加载中...',
    })
    let base64Img = Taro.getFileSystemManager().readFileSync(e, 'base64')
    api.uploadImg({ img_data: base64Img }).then(res => {
      if (res.code == 200) {
        // 传裁剪图片到上个页面
        var pages = Taro.getCurrentPages(); //获取当前页面栈
        if (pages.length >1) {
          var beforePage = pages[pages.length - 2]; //获取上一个页面实例对象
          console.log(beforePage,'beforePage');
          beforePage.setData({
            //返回参数 ps：这里我打印出beforePage只有一个setData能调用到
            consultImg: res.data,
            sizeIndex:this.state.sizeIndex
          },()=>{
            Taro.hideLoading()
            Taro.navigateBack({delta: 1}); //返回上一个页面
          })
        }
      }else{
        Taro.showToast({ title: res.msg, icon: 'none' })
      }
    })
    console.log(e,'cut');
  }
  onCancel(e){
    Taro.navigateBack({delta: 1})
  }

  componentDidMount () { }

  render () {
    return (
      <View className='wallet'>
        <ScrollView
          className='measurement-list'
          showScrollbar
          scrollX
        >
          {
            this.state.imgSize.map((item, index) => (
              <View className='measurement-info' style={this.state.sizeIndex == index ? 'border: 2px solid #0F84EC;' : ''} key={index} onClick={e => (this.changeMeasurement(item, index))}>
                <Image className='measurement-img' src={item.img}></Image>
                <View className='measurement-title'>{item.name}</View>
              </View>
            ))
          }
        </ScrollView>
        <View className='index'>
          <TaroCropper
            id='taro-cropper'
            src={this.state.src}
            // src='https://video-h5.fyshark.com/tmp/10581_168007502299.png'
            cropperWidth={this.state.cropperWidth}
            cropperHeight={this.state.cropperHeight}
            height={'1100'}
            hideCancelText={false}
            themeColor='#1084EC'
            onCut={res => {
              this.onCut(res)
            }}
            onCancel={e => (this.onCancel(e))}
          />
        </View>
      </View>
    )
  }
}
