import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import Taro, { } from '@tarojs/taro'
import tool from '../../common/tool'
import * as api from '../../service/index'
import './index.less'

export default class Mine extends Component {
  state = {
    all_coin: 0,
    page: 1,
    size: 20,
    total: true,
    walletList: [],
  }

  componentDidShow () {
    this.getUserCoinDetail()
  }
  getUserCoinDetail () {
    api.getUserCoinDetail({ page_size: this.state.size, page: this.state.page }).then(res => {
      let total = true
      if (res.data.data.length < this.state.size) {
        total = false
      }
      let walletList = this.state.walletList.concat(res.data.data)
      this.setState({
        all_coin: res.data.all_coin,
        walletList: walletList,
        total: total
      })
    })
  }
  onShareAppMessage = (res) => {
    let path = `/pages/index/index?c=${Taro.getStorageSync('user_id')}&s=rightTap`
    if (process.env.TARO_ENV == 'tt') {
      path = `/pages/index/index?c=channel_name&s=douyinguazai`
    }
    let shareData = {
      title: tool.shareTitle,
      path: path,
      imageUrl: tool.shareImg
    }
    return shareData;
  }

  onReachBottom () {
    if (!this.state.total)return
      this.setState({
        page: this.state.page + 1
      }, () => {
        this.getUserCoinDetail()
      })
  }
  toBuyPage (e) {
    Taro.navigateTo({
      url: `/pages/earnPoints/index`
    })
  }

  componentDidMount () { }

  render () {
    return (
      <View className='wallet'>
        <View className='user_info_div'>
          <View className='user-info-top'>
            <View className='user_info_txt_hit'>我的点券</View>
            <View className='user_info_money'>
              <View className='user_info_txt_money'>{this.state.all_coin}</View>
              <View className='user_info_btn' onClick={(e) => (this.toBuyPage(e))}  >充值点券</View>
            </View>
          </View>
        </View>

        <View className='wallet_detail_div'>
          {
            this.state.walletList.map((item, index) => (

              <View className='wallet_item_list' key={index}>
                <View className='wallet_item_list_left'>
                  <Text className='wallet-item-title'>{item.title}</Text>
                  {/* <Text className='wallet_item_list_hint'>{item.title}</Text> */}
                </View>
                <View className='wallet_item_list_right'>
                  <Text className='wallet-item-title'>{item.coin}</Text>
                  <Text className='wallet_item_list_hint'>{item.time}</Text>
                </View>

              </View>

            ))
          }

        </View>
        <View className='vallet-list-tips'>
          暂无更多记录~
        </View>

      </View>
    )
  }
}
